var SubmitToTab = {
  startup : function() {
    document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", SubmitToTab.onPopupShowing, false);

	// The function is different in Seamonkey 1.1; adjusted to work - JJF 03/01/2007
	eval("contentAreaClick =" + contentAreaClick.toString().replace(/(if \(pref &&\s*!isKeyCommand &&\s*event\.button == 1 && pref\.getBoolPref\("middlemouse\.contentLoadURL"\)\) \{)\s*(if \(middleMousePaste\(event\)\) \{\s*event\.stopPropagation\(\);\s*\})/, "$1 if(!SubmitToTab.contentAreaClick(event)){return false;} $2"));
	/*
    eval("contentAreaClick =" + contentAreaClick.toString().replace("if (event.button == 1 &&"
      ,'if(!SubmitToTab.contentAreaClick(event)){return false;} else if (event.button == 1 &&')
    );
	*/

    //insert into each browser
    var tb = document.getElementById("content");
	// This next line breaks tabs totally in Seamonkey - JJF 03/01/2007
    //eval("tb.addTab =" + tb.addTab.toString().replace(/(this\.onTitleChanged, (?:true|false)\);)/, "$1 SubmitToTab.fixAutoScroll(b);"));
    SubmitToTab.fixAutoScroll(tb.mCurrentBrowser);
  },

  fixAutoScroll : function(b) {
    eval("b.isAutoscrollBlocker =" + b.isAutoscrollBlocker.toString().replace(/(while\s?\(node\)\s?\{)/
      ,"$1 if(SubmitToTab.isFormNode(node)) return true;")
    );
  },

  /**
   * This method can be used by external extensions to plug into this extension.
   * The best place to add this method is in the switch statement in browser.js::contentAreaClick():
   * e.g.,
   *  switch (local_name) {
   * + case "button":
   * + case "input":
   * +   if(SubmitToTab.contentAreaClick(event) == false) return false;
   *   case "a":
   *   case "area":
   *   case "link": .....
  */
  contentAreaClick : function(event) {
    var target = event.target;
    if((event.button == 1 || (event.button == 0 && (event.ctrlKey || event.metaKey))) && SubmitToTab.isFormNode(target)) {
      SubmitToTab.submitFormToNewTab(event, target);
      return false;
    }
    else if(event.button == 0 && event.shiftKey && SubmitToTab.isFormNode(target)) {
      SubmitToTab.submitFormToNewWindow(target);
      return false;
    }
    return true;
  },

  onPopupShowing : function() {
    var isNode = SubmitToTab.isFormNode(document.popupNode);

    document.getElementById("context-submitform").hidden = !isNode;
    document.getElementById("context-submitformintab").hidden = !isNode;
    document.getElementById("context-sep-submit").hidden = !isNode;
  },

  isFormNode : function(node) {
    if(node instanceof HTMLInputElement || node instanceof HTMLButtonElement) {
      var att = new XPCNativeWrapper(node, "getAttribute()").getAttribute("type");
      if(!att) {
        if(node instanceof HTMLButtonElement) return true;
      } else {
        att = att.toUpperCase();
        if(att == "IMAGE" || att == "SUBMIT") return true;
      }
    }
    return false;
  },

  submitFormToNewWindow : function(formNode) {
    var node = (formNode) ? formNode : document.popupNode;
    node = new XPCNativeWrapper(node, "form", "click()");

    var oldTarget = node.form.getAttribute("target");
    node.form.target = "_blank";

    var oldOpenNewWinPref = null;
    try {
      oldOpenNewWinPref = gBrowser.mPrefs.getIntPref("browser.link.open_newwindow");
      gBrowser.mPrefs.setIntPref("browser.link.open_newwindow", 2);
    } catch(e) {}

    var oldBlockTargetNewWindow = false;
    try {
      oldBlockTargetNewWindow = gBrowser.mPrefs.getBoolPref("browser.block.target_new_window");
      if(oldBlockTargetNewWindow)
        gBrowser.mPrefs.setBoolPref("browser.block.target_new_window", false);
    } catch(e) {}

    var oldPopupBlock = null;
    try {
      oldPopupBlock = gBrowser.mPrefs.getBoolPref("dom.disable_open_during_load");
      gBrowser.mPrefs.setBoolPref("dom.disable_open_during_load", false);
    } catch(e) {}

    node.click();

    node.form.target = (oldTarget) ? oldTarget : "_self";

    if(oldPopupBlock != null) {
      gBrowser.mPrefs.setBoolPref("dom.disable_open_during_load", oldPopupBlock);
    }

    if(oldOpenNewWinPref != null) {
      gBrowser.mPrefs.setIntPref("browser.link.open_newwindow", oldOpenNewWinPref);
    }
    if(oldBlockTargetNewWindow) {
      gBrowser.mPrefs.setBoolPref("browser.block.target_new_window", true);
    }
  },

  submitFormToNewTab : function(aEvent, formNode) {
    var node = (formNode) ? formNode : document.popupNode;
    node = new XPCNativeWrapper(node, "form", "click()");

    var oldTarget = node.form.getAttribute("target");
    node.form.target = "_blank";

    var oldOpenNewWinPref = null;
    try {
      oldOpenNewWinPref = gBrowser.mPrefs.getIntPref("browser.link.open_newwindow");
      gBrowser.mPrefs.setIntPref("browser.link.open_newwindow", 3);
    } catch(e) {
      try {
        gBrowser.mPrefs.setIntPref("browser.link.open_newwindow", 3);
        oldOpenNewWinPref = 2;  //default value
      } catch(e2) {}
    }

    var oldDiverted = null;
    try {
      if(gBrowser.mPrefs.getBoolPref("browser.tabs.loadInBackground") ^ aEvent.shiftKey) {
        oldDiverted = gBrowser.mPrefs.getBoolPref("browser.tabs.loadDivertedInBackground");
        gBrowser.mPrefs.setBoolPref("browser.tabs.loadDivertedInBackground", true);
      }
    } catch(e) {}

    var oldPopupBlock = null;
    try {
      oldPopupBlock = gBrowser.mPrefs.getBoolPref("dom.disable_open_during_load");
      gBrowser.mPrefs.setBoolPref("dom.disable_open_during_load", false);
    } catch(e) {}

    node.click();

    node.form.target = (oldTarget) ? oldTarget : "_self";

    if(oldPopupBlock != null) {
      gBrowser.mPrefs.setBoolPref("dom.disable_open_during_load", oldPopupBlock);
    }

    if(oldDiverted != null) {
      gBrowser.mPrefs.setBoolPref("browser.tabs.loadDivertedInBackground", oldDiverted);
    }

    if(oldOpenNewWinPref != null) {
      gBrowser.mPrefs.setIntPref("browser.link.open_newwindow", oldOpenNewWinPref);
    }
  }
};

window.addEventListener("load", SubmitToTab.startup, false);
